package cds;

/**
 * Implementation of the Competitor thread. It repeats <code>ITERNUM</code>
 * accesses to the shared counter, whose reference is obtained at construction
 * time.
 */
public class Competitor extends Thread {

    static final int ITERNUM = 10; //number of iterations in the run() body

    private final SharedCounter count;
    private int id;

    public Competitor(SharedCounter count) {
        this.count = count;
    }

    @Override
    public void run() {
        id = ThreadSeqID.get(); //This cannot be placed in the constructor!!!
        int mycount; //, key;
        for (int i = 0; i < ITERNUM; i++) {
            mycount = count.get();
            String message = "";
            for (int j = 0; j < id; j++) {
                message = message + "             ";
            }
            message = message + "T" + Integer.toString(id) + " --> " + Integer.toString(mycount);
            System.out.println(message);
        }

    }

}
