package cds;

import java.util.Map;
import java.util.concurrent.locks.Lock;

public class MapCompetitor extends Thread {

    static final int ITERNUM = 30; //number of iterations in the run() body
    //the maximum time to sleep between ...
    static final int MAXSLEEP = 15;
    //the maximum # of elements in the map
    static final int MAXELEMS = 7;

    private final Map<Integer, Integer> map;
    private final Lock lock;
    private int id;

    public MapCompetitor(Map<Integer, Integer> map, Lock lock) {
        this.map = map;
        this.lock = lock;
    }

    @Override
    public void run() {
        id = ThreadSeqID.get(); //This cannot be placed in the constructor!!!
        Integer key;
        Integer value;
        java.util.Random myPRNG = new java.util.Random();
        for (int i = 0; i < ITERNUM; i++) {

            key = myPRNG.nextInt(MAXELEMS);

            lock.lock();
            try {
                boolean isPresent = map.containsKey(key);
                try {
                    Thread.sleep(myPRNG.nextInt(MAXSLEEP));
                } catch (InterruptedException e) {
                }

                if (isPresent) {
                    value = map.remove(key);
                    if (value == null) {
                        System.out.println("T" + Integer.toString(id) + "/" + Integer.toString(i) + " - The key (" + Integer.toString(key) + ") was indicated as present, but it is not!");
                    }
                } else {
                    map.put(key, key);
                }
            } finally {
                lock.unlock();
            }

        }

    }

}
