package cds;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;

class PetersonLock implements Lock {

    private final boolean[] flag = new boolean[2];
    //private final java.util.concurrent.atomic.AtomicIntegerArray flag = new java.util.concurrent.atomic.AtomicIntegerArray(2);
    private volatile int turn;

    @Override
    public void lock() throws UnsupportedOperationException {
        int i = ThreadSeqID.get();
        if (!(i == 0 || i == 1)) {
            throw new java.lang.UnsupportedOperationException("Peterson's solution works only with 2 threads!");
        }

        int j = 1 - i; //i.e., j refers to the other thread id
        flag[i] = true;
        //flag.set(i, 1);
        turn = j;
        while (turn == j && flag[j]) {
        //while (turn == j && flag.get(j)==1) {
        }
    }

    @Override
    public void unlock() {
        int i = ThreadSeqID.get();
        flag[i] = false;
        //flag.set(i, 0);
    }

    // Any class implementing Lock must provide these methods
    @Override
    public Condition newCondition() {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public boolean tryLock(long time, TimeUnit unit)
            throws InterruptedException {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public boolean tryLock() {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public void lockInterruptibly() throws InterruptedException {
        throw new java.lang.UnsupportedOperationException();
    }

}
